<?php

########################################################################################
# Dateiname:		getOBKPILast24.php
#
# Beschreibung:	Liefert KPI Kennzahlen der letzten 24h im JSON Format
#
# Author:		    Marc Mader (marc.mader@aem-et.de)
# Datum:		    24.11.2017
# Copyright:		AEM August Elektrotechnik GmbH, Seerasen 4-6, 36284 Hohenroda
#
#
#
#
########################################################################################

# Error Reporting einschalten
error_reporting(E_ALL);
ini_set('display_errors',1);

# Datenbankverbindung
function dbconnect()
{
    $link = mysql_connect("localhost", "buradmin", ".buradmin") or die("Keine Verbindung zur Datenbank moeglich!");
    mysql_select_db("BUR_PDA") or die("Die Datenbank BUR_PDA existiert nicht!");
    return $link;
}

# Hilfsfunktion für Debugging
# Gibt einen ResultSet als Tabelle aus
function tableFromRS($rs)
{
    echo "<table border=1>";
    for ($i = 0; $i < mysql_num_fields($rs); $i++) {
        $field_info = mysql_fetch_field($rs, $i);
        echo "<th>{$field_info->name}</th>";
    }
    while ($red = mysql_fetch_row($rs)) {

        echo "<tr>";
        foreach ($red as $v) {
            echo "<td>$v</td>";
        }
        echo "</tr>";
    }

    echo "</table>";
}



# Ermittelt die  AssetIntensity für den übergebenen Zeitbereich
#
# Parameter:
# ObLineID:	OrangeBox Line ID		<String>	("S7 Teststand")
# start:	Start Betrachtungszeitraum 	<String>	("2017-01-01 00:00:00")
# start:	Ende Betrachtungszeitraum 	<String>	("2017-12-31 23:59:59")
#
# Rückgabe:
#
# String
function getAIKPI($ObLineID, $starttime, $endtime)
{
    $dblink = dbconnect();
    $query  = '
                    SELECT
                      ((SELECT sum(product_counter) - sum(reject_counter) - sum(reject_counter_additional)) /
                          (
                              (SELECT sum(duration / 3600000) FROM OrangeBoxTimeline WHERE ob_line_id = "' . $ObLineID . '"
                                  and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '" and starttime < "' . $endtime . '" and state != "ASSET_IDLE") * (
                                  (SELECT sum(duration * nominalproductionrate / 3600000) / sum(duration / 3600000) FROM OrangeBoxTimeline WHERE ob_line_id = "' . $ObLineID . '"
                                      and state != "ASSET_IDLE"
                                      and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '" and starttime < "' . $endtime . '")
                              )
                          )) * 100
                  as assetintensity
                  FROM
                  OrangeBoxTimeline
                  WHERE
                  ob_line_id = "' . $ObLineID . '"
                  and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '" and starttime < "' . $endtime . '"';
    $result = mysql_query($query);
    return mysql_fetch_array($result);
    mysql_close($dblink);
}


# Ermittelt die  ungeplanten Stopps für den übergebenen Zeitbereich
#
# Parameter:
# ObLineID:	OrangeBox Line ID		<String>	("S7 Teststand")
# start:	Start Betrachtungszeitraum 	<String>	("2017-01-01 00:00:00")
# start:	Ende Betrachtungszeitraum 	<String>	("2017-12-31 23:59:59")
#
# Rückgabe:
#
# String
function getUnplStopsKPI($ObLineID, $starttime, $endtime)
{
    $dblink = dbconnect();
    $query  = 'SELECT
              (SELECT sum(duration) FROM `BUR_PDA`.
                  `OrangeBoxTimeline`
                  WHERE ob_line_id = "' . $ObLineID . '"
                  and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '"
                  and starttime <= "' . $endtime . '"
                  and state = "ASSET_UNSCHEDDT") /
              (SELECT sum(duration) FROM `BUR_PDA`.
                  `OrangeBoxTimeline`
                  WHERE ob_line_id = "' . $ObLineID . '"
                  and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '"
                  and starttime <= "' . $endtime . '"
                  and state != "ASSET_IDLE"
                  and state != "ASSET_SCHEDDT") * 100 as unplannedStoppages
  ';
    //echo $query;
    $result = mysql_query($query);
    return mysql_fetch_array($result);
    mysql_close($dblink);
}

# Ermittelt die  geplanten Stopps für den übergebenen Zeitbereich
#
# Parameter:
# ObLineID:	OrangeBox Line ID		<String>	("S7 Teststand")
# start:	Start Betrachtungszeitraum 	<String>	("2017-01-01 00:00:00")
# start:	Ende Betrachtungszeitraum 	<String>	("2017-12-31 23:59:59")
#
# Rückgabe:
#
# String
function getPlStopsKPI($ObLineID, $starttime, $endtime)
{
    $dblink = dbconnect();
    $query  = 'SELECT
              (SELECT sum(duration) FROM `BUR_PDA`.
                  `OrangeBoxTimeline`
                  WHERE ob_line_id = "' . $ObLineID . '"
                  and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '"
                  and starttime < "' . $endtime . '"
                  and state = "ASSET_SCHEDDT") /
              (SELECT sum(duration) FROM `BUR_PDA`.
                  `OrangeBoxTimeline`
                  WHERE ob_line_id ="' . $ObLineID . '"
                  and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '"
                  and starttime < "' . $endtime . '"
                  and state != "ASSET_IDLE") * 100 as plannedStoppages
  ';
    //echo $query;
    $result = mysql_query($query);
    return mysql_fetch_array($result);
    mysql_close($dblink);
}


# Liest einen Prozesswert über Die IOS-Webschnittstelle
#
# Parameter:
#
# pv:		Name Prozessvariable	<String>	("OB00001_LineID")
function getPvVal($pv)
{

  $url    = 'https://localhost/iosys/MasterOrangeBox/RUNTIME01/json/get?id=' . $pv;
  $contents = file_get_contents($url);

   if ($contents !== false) {
     $pvraw = json_decode($contents, true);
     if (strcmp($pvraw[1][0]['flags'], "-VS--P") == 0)
     {
        return $pvraw[1][0]['val'];
     }
    else
    {
        return "---";
    }
    }
   else{
    return "---";
   }
}

# Array erzeugen
$json = array();

# Überprüfen ob eine OBLineID übergeben wurde, wenn nicht HTTP Bad Request Error (400) zurückmelden
if (isset($_REQUEST['line_id']) and strcmp($_REQUEST['line_id'],"") != 0) {
    $ObLineID = $_REQUEST['line_id'];
} else {
    header('X-PHP-Response-Code: 400', true, 400);
    echo "Error (400) - Bad Request.";
    exit;
}

# Überprüfen ob eine OBID übergeben wurde, wenn nicht HTTP Bad Request Error (400) zurückmelden
if (isset($_REQUEST['ob_id']) and strcmp($_REQUEST['ob_id'],"") != 0) {
    $ObID = $_REQUEST['ob_id'];
} else {
    header('X-PHP-Response-Code: 400', true, 400);
    echo "Error (400) - Bad Request.";

    exit;
}

# Start und Ende für Betrachtungszeitraum festlegen
# start = Jetzt - 24h
# ende  = Jetzt
$startdatetime = date("Y-m-d H:i:s", strtotime('-24 hours'));
$enddatetime = date("Y-m-d H:i:s");




# MIt Datenbank verbinden
$dblink = dbconnect();


# General Teil erzeugen
$json["general"]["line_id"] = $ObLineID;
$json["general"]["ob_id"] = $ObID;
$json["general"]["query_start"] = $startdatetime;
$json["general"]["query_end"] = $enddatetime;

# Livewerte abfragen
$json['MachineState']['OperatingState'] = getPvVal($ObID . '_Status_InfoLine_AssetIntensity_MachineState');
$json['MachineState']['StateMessage'] = getPvVal($ObID . '_Dashboard_KPI_JobID');
$json['MachineState']['JobName'] = getPvVal($ObID . '_Dashboard_KPI_JobName');
$json['MachineState']['ProductName'] = getPvVal($ObID . '_Dashboard_KPI_ProductName');
$json['MachineState']['ShiftName'] = getPvVal($ObID . '_Dashboard_KPI_ShiftName');

# Werte der letzten 24h ermitteln
$json['KPI']['start'] = $startdatetime;
$json['KPI']['end'] = $enddatetime;

$tmp = getAIKPI($ObLineID, $startdatetime, $enddatetime );
$json['KPI']['AssetIntensity'] = $tmp['assetintensity'];

$tmp = getUnplStopsKPI($ObLineID, $startdatetime, $enddatetime );
$json['KPI']['unplannedStoppages'] = $tmp['unplannedStoppages'];

$tmp = getPlStopsKPI($ObLineID, $startdatetime, $enddatetime );
$json['KPI']['plannedStoppages'] = $tmp['plannedStoppages'];



# JSON Ausgabe erzeugen
echo json_encode($json);
?>
