<?php
########################################################################################
# Dateiname:		getOBKPIYear.php
#
# Beschreibung:		Liefert KPI Kennzahlen der letzten 12 Monate im JSON Format
#
# Author:		Marc Mader (marc.mader@aem-et.de)
# Datum:		24.11.2017
# Copyright:		AEM August Elektrotechnik GmbH, Seerasen 4-6, 36284 Hohenroda
#
#
#
#
########################################################################################

# Error Reporting einschalten
error_reporting(E_ALL);
ini_set("display_errors",1);

# Datenbankverbindung
function dbconnect()
{
    $link = mysql_connect("localhost", "buradmin", ".buradmin") or die("Keine Verbindung zur Datenbank moeglich!");
    mysql_select_db("BUR_PDA") or die("Die Datenbank BUR_PDA existiert nicht!");
    return $link;
}

# Hilfsfunktion für Debugging
# Gibt einen ResultSet als Tabelle aus
function tableFromRS($rs)
{
    echo "<table border=1>";
    for ($i = 0; $i < mysql_num_fields($rs); $i++) {
        $field_info = mysql_fetch_field($rs, $i);
        echo "<th>{$field_info->name}</th>";
    }
    while ($red = mysql_fetch_row($rs)) {

        echo "<tr>";
        foreach ($red as $v) {
            echo "<td>$v</td>";
        }
        echo "</tr>";
    }

    echo "</table>";
}


# Ermittelt die monatliche AssetIntensity für den übergebenen Zeitbereich
#
# Parameter:
# ObLineID:	OrangeBox Line ID		<String>	("S7 Teststand")
# start:	Start Betrachtungszeitraum 	<String>	("2017-01-01 00:00:00")
# start:	Ende Betrachtungszeitraum 	<String>	("2017-12-31 23:59:59")
#
# Rückgabe:
#
# Array mit Elementen von der Struktur
# {start, end, xAxisDesc, value}
function getAIKPI($ObLineID, $start, $end)
{
    $rows = array();
    $dblink = dbconnect();
    $setlocalequery = "SET lc_time_names = 'de_DE'";
    $query  = '
                SELECT
                      DATE_FORMAT(DATE_SUB(starttime, INTERVAL DAYOFMONTH(starttime)-1 DAY) ,"%Y-%m-%d 06:00:00")as start,
		      DATE_FORMAT(DATE_ADD(LAST_DAY(starttime), INTERVAL 1 DAY),"%Y-%m-%d 06:00:00")  as end,
                       CONCAT(YEAR(starttime),"-",IF(MONTH(starttime)<10, CONCAT("0",MONTH(starttime)),MONTH(starttime)))as `xAxisDesc`,
                      (
                    sum(product_counter) -
                    (sum(reject_counter) +
                    sum(reject_counter_additional)	)
                      )
                      /
                      ((SELECT sum(duration / 3600000) FROM `BUR_PDA`.`OrangeBoxTimeline` WHERE ob_line_id="'. $ObLineID .'" and DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) > start  and starttime <  end    and state!="ASSET_IDLE") *
                      ((SELECT sum(duration * nominalproductionrate / 3600000) / sum(duration / 3600000) FROM BUR_PDA.`OrangeBoxTimeline`  WHERE state!="ASSET_IDLE" and ob_line_id="'. $ObLineID .'" and DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) >  start  and starttime <   end   ))
                      ) * 100
                      as value
                  FROM
                      BUR_PDA.`OrangeBoxTimeline`
                  WHERE
                      ob_line_id ="'. $ObLineID .'" and
                      DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) >  "' . $start . '"  and starttime <=  "' . $end . '"
                  GROUP BY
                      `xAxisDesc`
		  ORDER BY
                      `xAxisDesc` ASC


                ';
    mysql_query($setlocalequery);
    $result = mysql_query($query);

    while($row = mysql_fetch_assoc($result))
    {
        array_push($rows, $row);
    }
    mysql_close($dblink);
     if (count($rows) > 0)
    {
        return $rows;
    }
    else
    {
        return null;
    }
}

# Ermittelt AssetIntensity für den übergebenen Zeitbereich
#
# Parameter:
# ObLineID:	OrangeBox Line ID		<String>	("S7 Teststand")
# start:	Start Betrachtungszeitraum 	<String>	("2017-01-01 00:00:00")
# start:	Ende Betrachtungszeitraum 	<String>	("2017-12-31 23:59:59")
#
# Rückgabe:
#
# Array mit Elementen von der Struktur
# {start, end, xAxisDesc, value}
function getAIKPIOverall($ObLineID, $starttime, $endtime)
{
    $dblink = dbconnect();
    $query  = '
                    SELECT
                      ((SELECT sum(product_counter) - sum(reject_counter) - sum(reject_counter_additional)) /
                          (
                              (SELECT sum(duration / 3600000) FROM OrangeBoxTimeline WHERE ob_line_id = "' . $ObLineID . '"
                                  and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '" and starttime < "' . $endtime . '" and state != "ASSET_IDLE") * (
                                  (SELECT sum(duration * nominalproductionrate / 3600000) / sum(duration / 3600000) FROM OrangeBoxTimeline WHERE ob_line_id = "' . $ObLineID . '"
                                      and state != "ASSET_IDLE"
                                      and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '" and starttime < "' . $endtime . '")
                              )
                          )) * 100
                  as assetintensity
                  FROM
                  OrangeBoxTimeline
                  WHERE
                  ob_line_id = "' . $ObLineID . '"
                  and DATE_ADD(starttime, INTERVAL(duration / 1000) SECOND) > "' . $starttime . '" and starttime < "' . $endtime . '"';
    $result = mysql_query($query);
    return mysql_fetch_array($result);
    mysql_close($dblink);
}

# Ermittelt die monatlichen ungeplanten Stopps für den übergebenen Zeitbereich
#
# Parameter:
# ObLineID:	OrangeBox Line ID		<String>	("S7 Teststand")
# start:	Start Betrachtungszeitraum 	<String>	("2017-01-01 00:00:00")
# start:	Ende Betrachtungszeitraum 	<String>	("2017-12-31 23:59:59")
#
# Rückgabe:
#
# Array mit Elementen von der Struktur
# {start, end, xAxisDesc, value}
function getUnplStopsKPI($ObLineID, $start, $end)
{
    $rows = array();
    $dblink = dbconnect();
    $setlocalequery = "SET lc_time_names = 'de_DE'";
    mysql_query($setlocalequery);
    $query  = 'SELECT
                     DATE_FORMAT(DATE_SUB(starttime, INTERVAL DAYOFMONTH(starttime)-1 DAY) ,"%Y-%m-%d 06:00:00")as start,
		     DATE_FORMAT(DATE_ADD(LAST_DAY(starttime), INTERVAL 1 DAY),"%Y-%m-%d 06:00:00")  as end,
                     CONCAT(YEAR(starttime),"-",IF(MONTH(starttime)<10, CONCAT("0",MONTH(starttime)),MONTH(starttime)))as `xAxisDesc`,
                    (sum(duration)/
                    (SELECT sum(duration) FROM `BUR_PDA`.`OrangeBoxTimeline` WHERE ob_line_id="'. $ObLineID .'" and state!="ASSET_IDLE" and state!="ASSET_SCHEDDT" and DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) >  start and starttime <  end )  * 100) as value

                FROM
                    BUR_PDA.`OrangeBoxTimeline`
                WHERE
                    ob_line_id= "'. $ObLineID .'" and
                    state="ASSET_UNSCHEDDT" and
                    DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) >  "' . $start . '"  and starttime <=  "' . $end . '"
                group by
		  xAxisDesc
		ORDER BY
                      `xAxisDesc` ASC
  ';
    //echo $query;
    $result = mysql_query($query);

    while($row = mysql_fetch_assoc($result))
    {
        array_push($rows, $row);
    }
    mysql_close($dblink);
     if (count($rows) > 0)
    {
        return $rows;
    }
    else
    {
        return null;
    }
}

# Ermittelt die monatlichen geplanten Stopps für den übergebenen Zeitbereich
#
# Parameter:
# ObLineID:	OrangeBox Line ID		<String>	("S7 Teststand")
# start:	Start Betrachtungszeitraum 	<String>	("2017-01-01 00:00:00")
# start:	Ende Betrachtungszeitraum 	<String>	("2017-12-31 23:59:59")
#
# Rückgabe:
#
# Array mit Elementen von der Struktur
# {start, end, xAxisDesc, value}
function getPlStopsKPI($ObLineID, $start, $end)
{
    $rows = array();
    $dblink = dbconnect();
    $setlocalequery = "SET lc_time_names = 'de_DE'";
    mysql_query($setlocalequery);
    $query  = 'SELECT
                DATE_FORMAT(DATE_SUB(starttime, INTERVAL DAYOFMONTH(starttime)-1 DAY) ,"%Y-%m-%d 06:00:00")as start,
		     DATE_FORMAT(DATE_ADD(LAST_DAY(starttime), INTERVAL 1 DAY),"%Y-%m-%d 06:00:00")  as end,
                     CONCAT(YEAR(starttime),"-",IF(MONTH(starttime)<10, CONCAT("0",MONTH(starttime)),MONTH(starttime)))as `xAxisDesc`,
                    (sum(duration)/
                    (SELECT sum(duration) FROM `BUR_PDA`.`OrangeBoxTimeline` WHERE ob_line_id="'. $ObLineID .'" and state!="ASSET_IDLE" and DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) >  start and starttime <  end )  * 100) as value

                FROM
                    BUR_PDA.`OrangeBoxTimeline`
                WHERE
                    ob_line_id= "'. $ObLineID .'" and
                    state="ASSET_SCHEDDT" and
                    DATE_ADD(starttime, INTERVAL (duration/1000) SECOND) >  "' . $start . '"  and starttime <=  "' . $end . '"
                group by
		  xAxisDesc
		ORDER BY
                      `xAxisDesc` ASC
  ';
    //echo $query;
    $result = mysql_query($query);

    while($row = mysql_fetch_assoc($result))
    {
        array_push($rows, $row);
    }
    mysql_close($dblink);
     if (count($rows) > 0)
    {
        return $rows;
    }
    else
    {
        return null;
    }
}


# Liest einen Prozesswert über Die IOS-Webschnittstelle
#
# Parameter:
#
# pv:		Name Prozessvariable	<String>	("OB00001_LineID")
function getPvVal($pv)
{

  $url    = "https://localhost/iosys/MasterOrangeBox/RUNTIME01/json/get?id=" . $pv;
  $contents = file_get_contents($url);

   if ($contents !== false) {
     $pvraw = json_decode($contents, true);
     // echo var_dump($pvraw);
     return $pvraw[1][0]["val"];
    }
   else{
    return null;
   }
}


# Array erzeugen
$json = array();

# Überprüfen ob eine OBLineID übergeben wurde, wenn nicht HTTP Bad Request Error (400) zurückmelden
if (isset($_REQUEST["line_id"]) and strcmp($_REQUEST["line_id"],"") != 0) {
    $ObLineID = $_REQUEST["line_id"];
} else {

    header("X-PHP-Response-Code: 400", true, 400);
    return;
}



# Start und Ende für Betrachtungszeitraum festlegen
# start = 1. Tag des aktuellen Monats 06:00:00Uhr - 12 Monate
# ende  = Jetzt
$startdatetime = date("Y-m-d H:i:s", strtotime(date("Y-m-01 06:00:00") . "- 12 Month"));
$enddatetime = date("Y-m-d H:i:s");




# Mit Datenbank verbinden
$dblink = dbconnect();


# Allgemeine Informationen
$json["general"]["line_id"] = $ObLineID;
$json["general"]["query_start"] = $startdatetime;
$json["general"]["query_end"] = $enddatetime;

# AssetIntensity monatsweise berechnen
$tmp = getAIKPI($ObLineID, $startdatetime, $enddatetime);
$json["KPI_AssetIntensity"]= $tmp;

# Geplante Stopps monatsweise berechnen
$tmp = getPlStopsKPI($ObLineID, $startdatetime, $enddatetime);
$json["KPI_PlannedStoppages"]= $tmp;

# Ungeplante Stopps monatsweise berechnen
$tmp = getUnplStopsKPI($ObLineID, $startdatetime, $enddatetime);
$json["KPI_UnplannedStoppages"]= $tmp;

# AssetIntensity Gesamtwert berechnen
$tmp = getAIKPIOverall($ObLineID,  date("Y-m-d 06:00:00", strtotime('first day of january')), $enddatetime );
$json["KPIAIoverall"]["start"] =date("Y-m-d 06:00:00", strtotime('first day of january'));
$json["KPIAIoverall"]["end"] = $enddatetime;
$json['KPIAIoverall']['value'] = $tmp['assetintensity'];

# JSON Ausgabe erzeugen
echo json_encode($json);
?>
