<?php

########################################################################################
# Dateiname:		getOBList.php
#
# Beschreibung:	Liefert eine Liste der konfigurierten OBs im JSON Format
#
# Author:		    Marc Mader (marc.mader@aem-et.de)
# Datum:		    24.11.2017
# Copyright:		AEM August Elektrotechnik GmbH, Seerasen 4-6, 36284 Hohenroda
#
#
#
#
########################################################################################

# Error Reporting einschalten
error_reporting(E_ALL);

# Arrays erzeugen
$json         = array();
$oblist       = array();
$rawOBVarList = array();

# MOB_ID und MOB_Location abfragen
$url          = 'https://localhost/iosys/MasterOrangeBox/RUNTIME01/json/get?id=MOB_ID,MOB_Location';
$contents     = file_get_contents($url);
if ($contents !== false) {
    $MOBraw                           = json_decode($contents, true);
    //var_dump($MOBraw);
    $json['MOB_Info']['MOB_ID']       = $MOBraw[1][0]['val'];
    $json['MOB_Info']['MOB_Location'] = $MOBraw[1][1]['val'];

} else {
    $json['MOB_Info']['MOB_ID']       = "";
    $json['MOB_Info']['MOB_Location'] = "";
}



# Generelle OB Infos für alle 50 OBs abfragen und in temporäres Array legen
for ($i = 1; $i <= 50; $i++) {
    $url = 'https://localhost/iosys/MasterOrangeBox/RUNTIME01/json/get?id=';
    $url .= 'MOB_Settings_OB00' . str_pad($i, 2, '0', STR_PAD_LEFT) . '_Enable,';
    $url .= 'OB00' . str_pad($i, 2, '0', STR_PAD_LEFT) . '_Status_InfoLine_ID_LineOB,';
    $url .= 'MOB_Settings_OB00' . str_pad($i, 2, '0', STR_PAD_LEFT) . '_LineDesc,';
    $url .= 'MOB_Settings_OB00' . str_pad($i, 2, '0', STR_PAD_LEFT) . '_IPAddress,';
    $contents = file_get_contents($url);
    if ($contents !== false) {
        array_push($rawOBVarList, json_decode($contents, true));
    }

}


# Temporäres Array durchlaufen und OBs herausfiltern zu denen eine Kommunikationsverbindung besteht
for ($i = 0; $i < 50; $i++) {

    if (strcmp($rawOBVarList[$i][1][0]['val'], "1") == 0) {
        if (strcmp($rawOBVarList[$i][1][1]['flags'], "-VS--P") == 0)
        {
          $conState = "1";
          $ob = array(
              "ID" => "OB00" . str_pad($i + 1, 2, '0', STR_PAD_LEFT),
              "Line_ID" => $rawOBVarList[$i][1][1]['val'],
              "Line_Desc" => $rawOBVarList[$i][1][2]['val'],
              "IPAdrress" => $rawOBVarList[$i][1][3]['val'],
              "Connection_Status" => $conState
          );
          array_push($oblist, $ob);
        }
    }
}

# JSON Ausgabe erzeugen
$json['OB_Info'] = $oblist;
echo json_encode($json);

?>
